searchNodes=[{"doc":"This modules provides utility functions for load balancing using the best of two random choices. It is designed for use with sbroker and sregulator processes using the sbetter_meter meter. However any OTP process can use this module to do load balancing using the via naming format if the process is registered with and updates the sbetter_server . To use sbetter with via use names of the form {via, sbetter, {{Broker, ...}, ask | ask_r}} . Where {Broker, ...} is a tuple containing pid() | atom() | {global, any()} | {via, module(), any()} | {atom(), node()} . The process with the small value/shortest sojourn time of two random processes for the ask (or ask_r ) queue will be called. The sojourn time includes the message queue delay and the time spent waiting in the internal queue. Comparing values/sojourn times requires ets lookups. However it is not required to carry out the lookups for every request to get well balanced queues. To only compare two random choices 20% of the time and use sscheduler the remaining 80% use scheduler_ask and scheduler_ask_r , or to only compare two random choices 20% of the time and choose a random process the reamining 80% use rand_ask and rand_ask_r . This ratio is chosen as the majority of the gain in choosing two random choices can be captured by giving 20% of requests a choice. See section 4.5 of the reference for more information. It is not possible to locally look up the pid of a process with name {atom(), node()} if the node is not the local node. Therefore a registered name on another node is not supported for use with this module. If a chosen process is not local the call may exit with {badnode, node()} . If a chosen process is not registered with the sbetter_server the call may exit with {nobetter, pid()} . The sbetter_meter will register with the server. However other methods can be used to register and update the sbetter_server . Registering with the sbetter_server must be done with sbetter_server:register/3 and not using start_link({via, sbetter, ...}, ...) . See also: sbetter_meter , sbetter_server .","ref":"sbetter.html","title":"sbetter","type":"module"},{"doc":"Sends a message to a process from a tuple of processes using the best of two random choices for the queue (or possibly using the current scheduler id). Returns ok if a process could be chosen otherwise exits.","ref":"sbetter.html#send/2","title":"sbetter.send/2","type":"function"},{"doc":"Lookup a pid from a tuple of pids using the best of two random choices for the queue (or possibly using the current scheduler id). If no process is associated with the chosen process returns undefined .","ref":"sbetter.html#whereis_name/1","title":"sbetter.whereis_name/1","type":"function"},{"doc":"","ref":"sbetter.html#t:method/0","title":"sbetter.method/0","type":"type"},{"doc":"Registers the process with and updates the sbetter_server with approximate queue sojourn times for use with the sbetter load balancer. sbetter_meter can be used as the sbroker_meter in a sbroker or a sregulator . It will provide the capability to do best of 2 random choices load balancing, using sbetter , between sbroker or sregulator processes using the sojourn time of their queues. Its argument, spec() , is of the form: \#{ ask =&gt; \#{ upper =&gt; AskUpper : : non_neg_integer ( ) } , % default: 5000 ask_r =&gt; \#{ upper =&gt; AskRUpper : : non_neg_integer ( ) } , % default: 5000 update =&gt; Update : : pos_integer ( ) } % default: 100 AskUpper is the maximum ask sojourn time in milliseconds (defaults to 5000 ) and AskRUpper is the maximum ask_r sojourn time in milliseconds (defaults to 5000 ) that will be updated to the sbetter_server for use with sbetter . If a match doesn't occur on the sbroker or sregulator the approximate sojourn time will increase unbounded for one of the two queues. Limiting this value prevents the situation where one process becomes stuck as the &quot;worst&quot; option because it hasn't matched for the longest when the processes' queues would be equivalently &quot;bad&quot;. For example if using the sbroker_timeout_queue with (the default) timeout of 5000 , then all requests are dropped after 5000 and so become approximately equivalent once the sojourn time is 5000 milliseconds. Update is the update interval in milliseconds when the process is idle (defaults to 100 ). See also: sbetter , sbetter_server .","ref":"sbetter_meter.html","title":"sbetter_meter","type":"module"},{"doc":"","ref":"sbetter_meter.html#t:spec/0","title":"sbetter_meter.spec/0","type":"type"},{"doc":"Server for storing the ask and ask_r values for load balanacing processes with sbetter .","ref":"sbetter_server.html","title":"sbetter_server","type":"module"},{"doc":"Register the local process Pid with the server and sets the ask and ask_r values (such as sojourn times) as integer values AskValue and AskRValue . Returns true if the process is successfully registered, or false if already registered.","ref":"sbetter_server.html#register/3","title":"sbetter_server.register/3","type":"function"},{"doc":"Unregister the process Pid with the server. The server will synchronously unlink from Pid .","ref":"sbetter_server.html#unregister/1","title":"sbetter_server.unregister/1","type":"function"},{"doc":"Update the ask and ask_r with values (such as sojourn times) as integer values AskValue and AskRValue for Pid . Returns true if the values were updated, or false if Pid is not registered with the server.","ref":"sbetter_server.html#update/3","title":"sbetter_server.update/3","type":"function"},{"doc":"This module provides a process match making service. A process joins one of two queues and is matched with a process in the other queue. The queues are managed using sbroker_queue callback module per queue so that a different strategy can be used for both queues. Processes that die while in a queue are automatically removed to prevent matching with a process that is nolonger alive. A broker also uses an sbroker_meter callback module to monitor the queue and processing delays of the broker. There are two functions to join a queue: ask/1 and ask_r/1 . Processes that call ask/1 are matched against processes that call ask_r/1 . If no match is immediately available a process is queued in the relevant queue until a match becomes available. If queue management is used processes may be dropped without a match. Processes calling ask/1 try to match with/dequeue a process in the ask_r queue. If no process exists they are queued in the ask queue and await a process to call ask_r/1 . Similarly processes calling ask_r/1 try to match with/dequeue a process in the ask queue. If no process exists they are queued in the ask_r queue and await a process to call ask/1 . A broker requires a callback module. The callback modules implements one callback, init/1 , with single argument Args . init/1 should return {ok, {AskQueueSpec, AskRQueueSpec, [MeterSpec]}) or ignore . AskQueueSpec is the queue specification for the ask queue, AskRQueueSpec is the queue specification for the ask_r queue and MeterSpec is a meter specification. There can any number of meters but a meter module can only be included once. In the case of ignore the broker is not started and start_link returns ignore . As the callback modules are defined in the init/1 callback a broker supports the dynamic modules supervisor child specification. Both queue and meter specifcations take the form: {Module, Args} . Module is the callback module and Args are its arguments. For example: - module ( sbroker_example ) . - behaviour ( sbroker ) . - export ( [ start_link / 0 ] ) . - export ( [ ask / 0 ] ) . - export ( [ ask_r / 1 ] ) . - export ( [ init / 1 ] ) . start_link ( ) -&gt; sbroker : start_link ( { local , ? MODULE } , ? MODULE , [ ] , [ ] ) . ask ( ) -&gt; sbroker : ask ( ? MODULE ) . ask_r ( ) -&gt; sbroker : ask_r ( ? MODULE ) . init ( [ ] ) -&gt; AskQueueSpec = { sbroker_codel_queue , \#{ } } , AskRQueueSpec = { sbroker_timeout_queue , \#{ } } , MeterSpec = { sbroker_overload_meter , \#{ alarm =&gt; { overload , ? MODULE } } } , { ok , { AskQueueSpec , AskRQueueSpec , [ MeterSpec ] } } .","ref":"sbroker.html","title":"sbroker","type":"behaviour"},{"doc":"Equivalent to ask(Broker, self()) .","ref":"sbroker.html#ask/1","title":"sbroker.ask/1","type":"function"},{"doc":"Send a match request, with value ReqValue , to try to match with a process calling ask_r/2 on the broker, Broker . Returns {go, Ref, Value, RelativeTime, SojournTime} on a successful match or {drop, SojournTime} . value of the matched request sent by the counterparty process. RelativeTime is the approximate time differnece (in the broker's time unit) between when the request was sent and the matching request was sent. SojournTime is the approximate time spent in both the broker's message queue and internal queue. RelativeTime represents the SojournTime without the overhead of the broker. The value measures the level of queue congestion without being effected by the load of the broker. If RelativeTime is positive, the request was enqueued in the internal queue awaiting a match with another request sent approximately RelativeTime after this request was sent. Therefore SojournTime minus RelativeTime is the latency, or overhead, of the broker. If RelativeTime is negative, the request dequeued a request in the internal queue that was sent approximately RelativeTime before this request was sent. Therefore SojournTime is the latency, or overhead, of the broker. If RelativeTime is 0 , the request was matched with a request sent at approximately the same time. Therefore SojournTime is the latency, or overhead, of the broker. The sojourn time for matched process can be approximated by SojournTime minus RelativeTime . If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request.","ref":"sbroker.html#ask/2","title":"sbroker.ask/2","type":"function"},{"doc":"Equivalent to ask_r(Broker, self()) .","ref":"sbroker.html#ask_r/1","title":"sbroker.ask_r/1","type":"function"},{"doc":"Tries to match with a process calling ask/2 on the same broker. See also: ask/2 .","ref":"sbroker.html#ask_r/2","title":"sbroker.ask_r/2","type":"function"},{"doc":"Equivalent to async_ask(Broker, self()) .","ref":"sbroker.html#async_ask/1","title":"sbroker.async_ask/1","type":"function"},{"doc":"Monitors the broker and sends an asynchronous request to match with a process calling ask_r/2 . Returns {await, Tag, Pid} or {drop, 0} . Tag is a monitor reference() that uniquely identifies the reply containing the result of the request. Process , is the pid() of the monitored broker or {atom(), node()} if the broker is registered locally in another node. To cancel the request call cancel(Process, Tag) . The reply is of the form {Tag, {go, Ref, Value, RelativeTime, SojournTime} or {Tag, {drop, SojournTime}} . Ref is the transaction reference, which is a reference() . Value is the value of the matched process. RelativeTime is the time spent waiting for a match after discounting time spent waiting for the broker to handle requests. SojournTime is the time spent in the broker's message queue. Multiple asynchronous requests can be made from a single process to a broker and no guarantee is made of the order of replies. A process making multiple requests can reuse the monitor reference for subsequent requests to the same broker process ( Process ) using async_ask/3 . If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: async_ask/3 , cancel/2 .","ref":"sbroker.html#async_ask/2","title":"sbroker.async_ask/2","type":"function"},{"doc":"Sends an asynchronous request to match with a process calling ask_r/2 . Returns {await, Tag, Pid} . To is a tuple containing the process, pid() , to send the reply to and Tag , any() , that identifies the reply containing the result of the request. Process is the pid() of the broker or {atom(), node()} if the broker is registered locally on a different node. To cancel all requests identified by Tag on broker Process call cancel(Process, Tag) . The reply is of the form {Tag, {go, Ref, Value, RelativeTime, SojournTime} or {Tag, {drop, SojournTime}} . Ref is the transaction reference, which is a reference() . Value is the value of the matched process. RelativeTime is the time spent waiting for a match after discounting time spent waiting for the broker to handle requests. SojournTime is the time spent in the broker's message queue. Multiple asynchronous requests can be made from a single process to a broker and no guarantee is made of the order of replies. If the broker exits or is on a disconnected node there is no guarantee of a reply and so the caller should take appropriate steps to handle this scenario. If the request is dropped when using via module sprotector , returns {drop, 0} and does not send the request. See also: cancel/2 .","ref":"sbroker.html#async_ask/3","title":"sbroker.async_ask/3","type":"function"},{"doc":"Equivalent to async_ask_r(Broker, self()) .","ref":"sbroker.html#async_ask_r/1","title":"sbroker.async_ask_r/1","type":"function"},{"doc":"Monitors the broker and sends an asynchronous request to match with a process calling ask/2 . See also: async_ask/2 , cancel/2 .","ref":"sbroker.html#async_ask_r/2","title":"sbroker.async_ask_r/2","type":"function"},{"doc":"Sends an asynchronous request to match with a process calling ask/2 . See also: async_ask/3 , cancel/2 .","ref":"sbroker.html#async_ask_r/3","title":"sbroker.async_ask_r/3","type":"function"},{"doc":"Await the response to an asynchronous request identified by Tag . Exits if a response is not received after Timeout milliseconds. Exits if a DOWN message is received with the reference Tag . See also: async_ask/2 , async_ask_r/2 .","ref":"sbroker.html#await/2","title":"sbroker.await/2","type":"function"},{"doc":"Equivalent to cancel(Broker, Tag, infinity) .","ref":"sbroker.html#cancel/2","title":"sbroker.cancel/2","type":"function"},{"doc":"Cancels an asynchronous request. Returns the number of cancelled requests or false if no requests exist. In the later case a caller may wish to check its message queue for an existing reply. See also: async_ask/1 , async_ask_r/1 .","ref":"sbroker.html#cancel/3","title":"sbroker.cancel/3","type":"function"},{"doc":"Equivalent to change_config(Broker, infinity) .","ref":"sbroker.html#change_config/1","title":"sbroker.change_config/1","type":"function"},{"doc":"Change the configuration of the broker. Returns ok on success and {error, Reason} on failure, where Reason , is the reason for failure. Broker calls the init/1 callback to get the new configuration. If init/1 returns ignore the config does not change.","ref":"sbroker.html#change_config/2","title":"sbroker.change_config/2","type":"function"},{"doc":"Cancels an asynchronous request. Returns ok without waiting for the broker to cancel requests. See also: cancel/3 .","ref":"sbroker.html#dirty_cancel/2","title":"sbroker.dirty_cancel/2","type":"function"},{"doc":"Equivalent to dynamic_ask(Broker, self()) .","ref":"sbroker.html#dynamic_ask/1","title":"sbroker.dynamic_ask/1","type":"function"},{"doc":"Tries to match with a process calling ask_r/2 on the same broker. If no immediate match available the request is converted to an async_ask/2 . Returns {go, Ref, Value, RelativeTime, SojournTime} on a successful match or {await, Tag, BrokerPid} . Ref is the transaction reference, which is a reference() . Value is the value of the matched process. RelativeTime is the time spent waiting for a match after discounting time spent waiting for the broker to handle requests. SojournTime is the time spent in the broker's message queue. Tag is a monitor reference and BrokerPid the pid() of the broker, as returned by async_ask/2 . If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: async_ask/2 , nb_ask/2 .","ref":"sbroker.html#dynamic_ask/2","title":"sbroker.dynamic_ask/2","type":"function"},{"doc":"Equivalent to dynamic_ask_r(Broker, self()) .","ref":"sbroker.html#dynamic_ask_r/1","title":"sbroker.dynamic_ask_r/1","type":"function"},{"doc":"Tries to match with a process calling ask/2 on the same broker. If no immediate match available the request is converted to an async_ask_r/2 . See also: dynamic_ask/2 .","ref":"sbroker.html#dynamic_ask_r/2","title":"sbroker.dynamic_ask_r/2","type":"function"},{"doc":"","ref":"sbroker.html#c:init/1","title":"sbroker.init/1","type":"callback"},{"doc":"Equivalent to len(Broker, infinity) .","ref":"sbroker.html#len/1","title":"sbroker.len/1","type":"function"},{"doc":"Get the length of the ask queue in the broker, Broker .","ref":"sbroker.html#len/2","title":"sbroker.len/2","type":"function"},{"doc":"Equivalent to len_r(Broker, infinity) .","ref":"sbroker.html#len_r/1","title":"sbroker.len_r/1","type":"function"},{"doc":"Get the length of the ask_r queue in the broker, Broker .","ref":"sbroker.html#len_r/2","title":"sbroker.len_r/2","type":"function"},{"doc":"Equivalent to nb_ask(Broker, self()) .","ref":"sbroker.html#nb_ask/1","title":"sbroker.nb_ask/1","type":"function"},{"doc":"Tries to match with a process calling ask_r/2 on the same broker but does not enqueue the request if no immediate match. Returns {go, Ref, Value, RelativeTime, SojournTime} on a successful match or {drop, SojournTime} . Ref is the transaction reference, which is a reference() . Value is the value of the matched process. RelativeTime is the time spent waiting for a match after discounting time spent waiting for the broker to handle requests. SojournTime is the time spent in the broker's message queue. If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: ask/2 .","ref":"sbroker.html#nb_ask/2","title":"sbroker.nb_ask/2","type":"function"},{"doc":"Equivalent to nb_ask_r(Broker, self()) .","ref":"sbroker.html#nb_ask_r/1","title":"sbroker.nb_ask_r/1","type":"function"},{"doc":"Tries to match with a process calling ask/2 on the same broker but does not enqueue the request if no immediate match. See also: nb_ask/2 .","ref":"sbroker.html#nb_ask_r/2","title":"sbroker.nb_ask_r/2","type":"function"},{"doc":"Starts a broker with callback module Module and argument Args , and broker options Opts . Opts is a proplist and supports debug , timeout and spawn_opt used by gen_server and gen_fsm . read_time_after sets the number of requests when a cached time is stale and the time is read again. Its value is non_neg_integer() or infinity and defaults to 16 . See also: gen_server:start_link/3 .","ref":"sbroker.html#start_link/3","title":"sbroker.start_link/3","type":"function"},{"doc":"Starts a broker with name Name , callback module Module and argument Args , and broker options Opts . See also: start_link/3 .","ref":"sbroker.html#start_link/4","title":"sbroker.start_link/4","type":"function"},{"doc":"","ref":"sbroker.html#timeout/1","title":"sbroker.timeout/1","type":"function"},{"doc":"","ref":"sbroker.html#t:broker/0","title":"sbroker.broker/0","type":"type"},{"doc":"","ref":"sbroker.html#t:debug_option/0","title":"sbroker.debug_option/0","type":"type"},{"doc":"","ref":"sbroker.html#t:handler_spec/0","title":"sbroker.handler_spec/0","type":"type"},{"doc":"","ref":"sbroker.html#t:name/0","title":"sbroker.name/0","type":"type"},{"doc":"","ref":"sbroker.html#t:start_option/0","title":"sbroker.start_option/0","type":"type"},{"doc":"","ref":"sbroker.html#t:start_return/0","title":"sbroker.start_return/0","type":"type"},{"doc":"Implements a head or tail drop queue with queue management based on CoDel (Controlling Queue Delay). sbroker_codel_queue can be used as a sbroker_queue in a sbroker or sregulator . It will provide a FIFO or LIFO queue that drops request in the queue using CoDel when the minimum size is exceeded, and drops the head or tail request from the queue when a maximum size is exceeded. Its argument, spec() , is of the form: \#{ out =&gt; Out : : out | out_r , % default: out target =&gt; Target : : non_neg_integer ( ) , % default: 100 interval =&gt; Interval : : pos_integer ( ) , % default: 1000 drop =&gt; Drop : : drop | drop_r , % default: drop_r min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Out is either out for a FIFO queue (the default) or out_r for a LIFO queue. Target is the target queue sojourn time in milliseconds (defaults to 100 ). Interval is in the initial interval in milliseconds (defaults to 1000 ) between drops when the queue is above the minimum size Min (defaults to 0 ). Drop is either drop_r for tail drop (the default) where the last request is droppped, or drop for head drop, where the first request is dropped. Dropping occurs when queue is above the maximum size Max (defaults to infinity ). Initial parameters are recommended to be between the 95th and 99th percentile round trip time for the interval and the target between 5% and 10% of the interval. The round trip should be that between the actual initiator of the request (e.g. a remote client) and the queue. For example, the reference suggests an interval of 100ms and a target of 5ms when queuing TCP packets in a kernel's buffer. A request and response might be a few more round trips at the packet level even if using a single :gen_tcp.send/2 . A person perceives a response time of 100 milliseconds or less as instantaneous, and feels engaged with a system if response times are 1000 milliseconds or less. Therefore it is desirable for a system to respond within 1000 milliseconds as a worst case (upper percentile response time) and ideally to respond within 100 milliseconds (target response time). These also match with the suggested ratios for CoDel and so the default target is 100 milliseconds and the default is interval 1000 milliseconds. This implementation differs from the reference as enqueue and other functions can detect a slow queue and drop items. However once a slow item has been detected only handle_out/2 can detect the queue becoming fast again with the caveat that with out_r this can only be detected if the queue reaches the minimum size Min or less, and not a fast sojourn time. This means that it is possible to drop items without calling handle_out/2 but it is not possible to stop dropping unless a handle_out/2 dequeues an item to take the queue to or below the minimum size Min or out is used and a dequeued request is below target sojourn time. Therefore if handle_out/2 is not called for an extended period the queue will converge to dropping all items above the target sojourn time if a single item has a sojourn time above target. Whereas with the reference implementation no items would be dropped. If it is possible for the counterparty in the broker to &quot;disappear&quot; for a period of time then setting a Min above 0 can leave Min items in the queue for an extended period of time as requests are only dropped when the queue size is above Min . This may be undesirable for client requests because the request could wait in the queue indefinitely if there are not enough requests to take the queue above Min . However it might be desired for database connections where it is ideal for a small number of connections to be waiting to handle a client request.","ref":"sbroker_codel_queue.html","title":"sbroker_codel_queue","type":"module"},{"doc":"","ref":"sbroker_codel_queue.html#t:spec/0","title":"sbroker_codel_queue.spec/0","type":"type"},{"doc":"Implements a head or tail drop queue. sbroker_drop_queue can be used as a sbroker_queue module in a sbroker or sregulator . It will provide a FIFO or LIFO queue that drops the head or tail request from the queue when a maximum size is exceeded. Its argument, spec() , is of the form: \#{ out =&gt; Out : : out | out_r , % default: out drop =&gt; Drop : : drop | drop_r , % default: drop_r max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Out is either out for a FIFO queue (the default) or out_r for a LIFO queue. Drop is either drop_r for tail drop (the default) where the last request is droppped, or drop for head drop, where the first request is dropped. Dropping occurs when queue is above the maximum size Max (defaults to infinity ).","ref":"sbroker_drop_queue.html","title":"sbroker_drop_queue","type":"module"},{"doc":"","ref":"sbroker_drop_queue.html#t:spec/0","title":"sbroker_drop_queue.spec/0","type":"type"},{"doc":"Implements a fair queue containing multiple sbroker_queue queues. sbroker_fair_queue can be used as a sbroker_queue in a sbroker or sregulator . It will provide a queue that enqueues requests to internal queues based on an index and dequeues from the internal queues fairly. Its argument, spec() , is of the form: { Module : : module ( ) , Args : : any ( ) , Index : : index ( ) } Module and Args are the module and arguments of the underlying sbroker_queue . Module must implement the sbroker_fair_queue behaviour. Index is the method of choosing the queue to store a request in. To use the application of the sender: application . If the application can not be determined uses undefined . To use the node of the sender: node . To use the pid of the sender: pid . To use the value of the request: value . To use the Nth element of a tuple value: {element, N} . If the value is not a tuple of at least size N uses undefined . One queue is used per key and so the number of possible keys should be bounded. If the underlying queue limits the size of its queue this only applies to the queue for that key. Requests with a different key will be in a different queue and be part of a separate limit. To limit the number of queues by hashing the key: {hash, Index2, Range} , where Index2 is any index() except another hash and Range is the number of queues, from 1 to 2^32. Queues are chosen using a simple round robin strategy. Request are dequeued and empty queues removed using the handle_fq_out/2 callback, instead of the usual handle_out/2 : - callback handle_fq_out ( Time : : integer ( ) , State : : any ( ) ) -&gt; { SendTime : : integer ( ) , From : : { Sender : : pid ( ) , Tag : : any ( ) } , Value : : any ( ) , Ref : : reference , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } | { empty , NState : : any ( ) , RemoveTime : : integer ( ) | infinity } . The variables are equivalent to those of the sbroker_queue callback handle_out/2 with the addition of RemoveTime , which is the time (or infinity for never) to remove the empty queue from the fair queue for that index.","ref":"sbroker_fair_queue.html","title":"sbroker_fair_queue","type":"behaviour"},{"doc":"","ref":"sbroker_fair_queue.html#c:handle_fq_out/2","title":"sbroker_fair_queue.handle_fq_out/2","type":"callback"},{"doc":"","ref":"sbroker_fair_queue.html#t:index/0","title":"sbroker_fair_queue.index/0","type":"type"},{"doc":"","ref":"sbroker_fair_queue.html#t:key/0","title":"sbroker_fair_queue.key/0","type":"type"},{"doc":"","ref":"sbroker_fair_queue.html#t:robin_queue/1","title":"sbroker_fair_queue.robin_queue/1","type":"type"},{"doc":"","ref":"sbroker_fair_queue.html#t:spec/0","title":"sbroker_fair_queue.spec/0","type":"type"},{"doc":"Behaviour for implementing meters for sbroker and sregulator . A custom meter must implement the sbroker_meter behaviour. The first callback is init/2 , which starts the meter: - callback init ( Time : : integer ( ) , Args : : any ( ) ) -&gt; { State : : any ( ) , UpdateTime : : integer ( ) | infinity } . Time is the time, in native time units, of the meter at creation. Some other callbacks will receive the current time of the meter as the second last argument. It is monotically increasing, so subsequent calls will have the same or a greater time. Args is the arguments for the meter. It can be any term. State is the state of the meter and used in the next call. UpdateTime represents the next time a meter wishes to call handle_update/4 to update itself. If a message is not recevued the update should occur at or after UpdateTime . The time must be greater than or equal to Time . If a meter does not require an update then UpdateTime should be infinity . When updating the meter, handle_update/5 : - callback handle_update ( QueueDelay : : non_neg_integer ( ) , ProcessDelay : : non_neg_integer ( ) , RelativeTime : : integer ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , UpdateTime : : integer ( ) | infinity } . QueueDelay is the approximate time a message spends in the message queue of the process. ProcessDelay is the average time spent processing a message since the last update. RelativeTime is an approximation of the RelativeTime for an ask request if a match was to occur immediately. If the process has not matched a request for a significant period of time this value can grow large and become inaccurate. The other variables are equivalent to those in init/2 , with NState being the new state. When handling a message, handle_info/3 : - callback handle_info ( Msg : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Msg is the message, and may be intended for another callback. The other variables are equivalent to those in init/2 , with NState being the new state. The other variables are equivalent to those in init/3 , with NState being the new state. When changing the state due to a code change, code_change/4 : - callback code_change ( OldVsn : : any ( ) , Time : : integer ( ) , State : : any ( ) , Extra : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . On an upgrade OldVsn is version the state was created with and on an downgrade is the same form except {down, OldVsn} . OldVsn is defined by the vsn attribute(s) of the old version of the callback module. If no such attribute is defined, the version is the checksum of the BEAM file. Extra is from {advanced, Extra} in the update instructions. The other variables are equivalent to those in init/3 , with NState being the new state. When changing the configuration of a queue, config_change/4 : - callback config_change ( Args : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/2 , with NState being the new state. When cleaning up the meter, terminate/2 : - callback terminate ( Reason : : sbroker_handlers : reason ( ) , State : : any ( ) ) -&gt; any ( ) . Reason is stop if the meter is being shutdown, change if the meter is being replaced by another meter, {bad_return_value, Return} if a previous callback returned an invalid term or {Class, Reason, Stack} if a previous callback raised an exception. State is the current state of the meter. The return value is ignored.","ref":"sbroker_meter.html","title":"sbroker_meter","type":"behaviour"},{"doc":"","ref":"sbroker_meter.html#c:code_change/4","title":"sbroker_meter.code_change/4","type":"callback"},{"doc":"","ref":"sbroker_meter.html#c:config_change/3","title":"sbroker_meter.config_change/3","type":"callback"},{"doc":"","ref":"sbroker_meter.html#c:handle_info/3","title":"sbroker_meter.handle_info/3","type":"callback"},{"doc":"","ref":"sbroker_meter.html#c:handle_update/5","title":"sbroker_meter.handle_update/5","type":"callback"},{"doc":"","ref":"sbroker_meter.html#c:init/2","title":"sbroker_meter.init/2","type":"callback"},{"doc":"","ref":"sbroker_meter.html#c:terminate/2","title":"sbroker_meter.terminate/2","type":"callback"},{"doc":"Sets an alarm when the process's message queue is slow for an interval. sbroker_overload_meter can be used as a sbroker_meter in a sbroker or a sregulator . It will set a SASL alarm_handler alarm when the process's message queue is slow for an interval and clear it once the message queue becomes fast for an interval. Its argument, spec() , is of the form: \#{ alarm =&gt; Alarm : : any ( ) , % default: {overload, self()} target =&gt; Target : : non_neg_integer ( ) , % default: 100 interval =&gt; Interval : : pos_integer ( ) } . % default: 1000 Alarm is the alarm_handler alarm that will be set/cleared by the meter (defaults to {overload, self()} ). Target is the target sojourn time of the message queue in milliseconds (defaults to 100 ). Interval is the interval in milliseconds (defaults to 1000 ) that the message queue must be above the target for the alarm to be set and below the target for the alarm to be cleared. The description of the alarm is {message_queue_slow, self()} . This meter detects when the process is receiving more requests than it can handle and not whether a sbroker_queue is congested. If a sbroker_queue becomes congested it will drop requests to clear the congestion, causing a congestion alarm (if one existed) to be cleared very quickly.","ref":"sbroker_overload_meter.html","title":"sbroker_overload_meter","type":"module"},{"doc":"","ref":"sbroker_overload_meter.html#t:spec/0","title":"sbroker_overload_meter.spec/0","type":"type"},{"doc":"Behaviour for implementing queues for sbroker and sregulator . A custom queue must implement the sbroker_queue behaviour. The first callback is init/3 , which starts the queue: - callback init ( InternalQueue : : internal_queue ( ) , Time : : integer ( ) , Args : : any ( ) ) -&gt; { State : : any ( ) , TimeoutTime : : integer ( ) | infinity } . InternalQueue is the internal queue of requests, it is a queue:queue() with items of the form {SendTime, From, Value, Reference} . SendTime is the approximate time the request was sent in native time units and is always less than or equal to Time . From is the a 2-tuple containing the senders pid and a response tag. SendTime and From can be used with drop/3 to drop a request. Value is any term, Reference is the monitor reference of the sender. Time is the time, in native time units, of the queue at creation. Some other callbacks will receive the current time of the queue as the second last argument. It is monotically increasing, so subsequent calls will have the same or a greater time. Args is the arguments for the queue. It can be any term. State is the state of the queue and used in the next call. TimeoutTime represents the next time a queue wishes to call handle_timeout/2 to drop items. If a message is not received the timeout should occur at or after TimeoutTime . The time must be greater than or equal to Time . If a queue does not require a timeout then TimeoutTime should be infinity . The value may be ignored or unavailable in other callbacks if the queue is empty. When inserting a request into the queue, handle_in/6 : - callback handle_in ( SendTime : : integer ( ) , From : : { Sender : : pid ( ) , Tag : : any ( ) } , Value : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/3 , with NState being the new state. When removing a request from the queue, handle_out/2 : - callback handle_out ( Time : : integer ( ) , State : : any ( ) ) -&gt; { SendTime : : integer ( ) , From : : { Sender : : pid ( ) , Tag : : any ( ) } , Value : : any ( ) , Ref : : reference , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } | { empty , NState : : any ( ) } . The variables are equivalent to those in init/3 , with NState being the new state. This callback either returns a single request, added in the InternalQueue from init/3 or enqueued with handle_in/6 . If the queue is empty an empty tuple is returned. When a timeout occurs, handle_timeout/2 : - callback handle_timeout ( Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/3 , with NState being the new state. When cancelling requests, handle_cancel/3 : - callback handle_cancel ( Tag : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { Reply : : false | pos_integer ( ) , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Tag is a response tag, which is part of the From tuple passed via InternalQueue in init/3 or directly in handle_in/6 . There may be multiple requests with the same tag and all should be removed. If no requests are cancelled the Reply is false , otherwise it is the number of cancelled requests. The other variables are equivalent to those in init/3 , with NState being the new state. When handling a message, handle_info/3 : - callback handle_info ( Msg : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Msg is the message, and may be intended for another queue. The other variables are equivalent to those in init/3 , with NState being the new state. When changing the state due to a code change, code_change/4 : - callback code_change ( OldVsn : : any ( ) , Time : : integer ( ) , State : : any ( ) , Extra : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . On an upgrade OldVsn is version the state was created with and on an downgrade is the same form except {down, OldVsn} . OldVsn is defined by the vsn attribute(s) of the old version of the callback module. If no such attribute is defined, the version is the checksum of the BEAM file. Extra is from {advanced, Extra} in the update instructions. The other variables are equivalent to those in init/3 , with NState being the new state. When changing the configuration of a queue, config_change/4 : - callback config_change ( Args : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/3 , with NState being the new state. When returning the number of queued requests, len/1 : - callback len ( State : : any ( ) ) -&gt; Len : : non_neg_integer ( ) . State is the current state of the queue and Len is the number of queued requests. This callback must be idempotent and so not drop any requests. When returning the send time of the oldest request in the queue, send_time/1 : - callback send_time ( State : : any ( ) ) -&gt; SendTime : : integer ( ) | empty . State is the current state of the queue and SendTime is the send time of the oldest request, if not requests then empty . This callback must be idempotent and so not drop any requests. When cleaning up the queue, terminate/2 : - callback terminate ( Reason : : sbroker_handlers : reason ( ) , State : : any ( ) ) -&gt; InternalQueue : : internal_queue ( ) . Reason is stop if the queue is being shutdown, change if the queue is being replaced by another queue, {bad_return_value, Return} if a previous callback returned an invalid term or {Class, Reason, Stack} if a previous callback raised an exception. State is the current state of the queue. InternalQueue is the same as init/3 and is passed to the next queue if Reason is change . The process controlling the queue may not be terminating with the queue and so terminate/2 should do any clean up required.","ref":"sbroker_queue.html","title":"sbroker_queue","type":"behaviour"},{"doc":"","ref":"sbroker_queue.html#c:code_change/4","title":"sbroker_queue.code_change/4","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:config_change/3","title":"sbroker_queue.config_change/3","type":"callback"},{"doc":"Drop a request from From , sent at SendTime from the queue. Call drop/3 when dropping a request from a queue.","ref":"sbroker_queue.html#drop/3","title":"sbroker_queue.drop/3","type":"function"},{"doc":"","ref":"sbroker_queue.html#c:handle_cancel/3","title":"sbroker_queue.handle_cancel/3","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:handle_in/5","title":"sbroker_queue.handle_in/5","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:handle_info/3","title":"sbroker_queue.handle_info/3","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:handle_out/2","title":"sbroker_queue.handle_out/2","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:handle_timeout/2","title":"sbroker_queue.handle_timeout/2","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:init/3","title":"sbroker_queue.init/3","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:len/1","title":"sbroker_queue.len/1","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:send_time/1","title":"sbroker_queue.send_time/1","type":"callback"},{"doc":"","ref":"sbroker_queue.html#c:terminate/2","title":"sbroker_queue.terminate/2","type":"callback"},{"doc":"","ref":"sbroker_queue.html#t:internal_queue/0","title":"sbroker_queue.internal_queue/0","type":"type"},{"doc":"Implements a head or tail drop queue with a timeout queue management algorithm sbroker_timeout_queue can be used as an sbroker_queue in a sbroker or sregulator . It will provide a FIFO or LIFO queue thats drops requests that remain in the queue for longer than a timeout when the minimum size is exceeded, and drops the head or tail request from the queue when a maximum size is exceeded. Its argument, spec() , is of the form: \#{ out =&gt; Out : : out | out_r , % default: out timeout =&gt; Timeout : : timeout ( ) , % default: 5000 drop =&gt; Drop : : drop | drop_r , % default: drop_r min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Out is either out for a FIFO queue (the default) or out_r for a LIFO queue. Timeout is timeout time in milliseconds or infinity (defaults to 5000 ) when requests are dropped from the queue when above the minimum size Min (defaults to 0 ). Drop is either drop_r for tail drop (the default) where the last request is droppped, or drop for head drop, where the first request is dropped. Dropping occurs when queue is above the maximum size Max (defaults to infinity ). If it is possible for the counterparty in the broker to &quot;disappear&quot; for a period of time then setting a Min above 0 can leave Min items in the queue for an extended period of time as requests are only dropped when the queue size is above Min . This may be undesirable for client requests because the request could wait in the queue indefinitely if there are not enough requests to take the queue above Min . However it might be desired for database connections where it is ideal for a small number of connections to be waiting to handle a client request.","ref":"sbroker_timeout_queue.html","title":"sbroker_timeout_queue","type":"module"},{"doc":"","ref":"sbroker_timeout_queue.html#t:spec/0","title":"sbroker_timeout_queue.spec/0","type":"type"},{"doc":"This module provides helpers for managing sbroker processes that are automatically started in the sbroker supervision tree. brokers can be automatically started when the sbroker application starts by setting the sbroker application env brokers . It is a list of broker names and specifications, of the form: [ { Name : : sbroker : name ( ) , Spec : : { AskQueueSpec : : sbroker : handler_spec ( ) , AskRQueueSpec : : sbroker : handler_spec ( ) , [ MeterSpec : : sbroker : handler_spec ( ) ] } } ] Name is the name of the broker and each broker will be registered using its name, e.g. {local, my_broker} . Spec is the specification for the sbroker , which is equivalent to returning {ok, Spec} from the init/1 callback: AskQueueSpec is the ask queue spec, AskRQueueSpec is the ask_r queue spec and MeterSpec is a meter spec. Starting brokers in the sbroker application allows multiple applications, or parts of the same supervision tree, to access a sbroker even if their counterparty crashes. It also allows either party to be started first and await the other using the sbroker queues.","ref":"sbroker_user.html","title":"sbroker_user","type":"module"},{"doc":"Call sbroker:change_config/1 on all brokers started in the sbroker application. This function can be used to reconfigure all brokers that are already started after the sbroker application env brokers is changed. Returns a list of failed changes, where Name is the sbroker:name() of the broker and Reason is the reason.","ref":"sbroker_user.html#change_config/0","title":"sbroker_user.change_config/0","type":"function"},{"doc":"Delete a broker with name, Name . The broker is deleted in the sbroker application's supervision tree using Brokers are automatically started when the sbroker is started, and might be restarted if the entry remains in the sbroker application env brokers , so this function should only be required to delete a broker after it has removed from brokers . Returns ok on successfully deleting the regulator, otherwise {error, Reason} where Reason is reason for the error.","ref":"sbroker_user.html#delete/1","title":"sbroker_user.delete/1","type":"function"},{"doc":"Restart a broker with name, Name . The broker is restarted in the sbroker application's supervision tree using configuration from the sbroker application env brokers . Brokers are automatically started when the sbroker is started so this function should only be required if a broker is terminated. Returns {ok, Pid} on starting the broker, where Pid is the pid() of the broker, {ok, undefined} if a configuration for Name does not exist in brokers or {error, Reason} if the broker fails to start with reason Reason .","ref":"sbroker_user.html#restart/1","title":"sbroker_user.restart/1","type":"function"},{"doc":"Starts a broker with name, Name . The broker is started in the sbroker application's supervision tree using configuration from the sbroker application env brokers . Brokers are automatically started when the sbroker application is started so this function should only be required if a broker is added to the configuration. Returns {ok, Pid} on starting the broker, where Pid is the pid() of the broker, {ok, undefined} if a configuration for Name does not exist in brokers or {error, Reason} if the broker fails to start with reason Reason .","ref":"sbroker_user.html#start/1","title":"sbroker_user.start/1","type":"function"},{"doc":"Terminate a broker with name, Name . The broker is terminated in the sbroker application's supervision tree. Brokers are automatically started when the sbroker is started, and might be restarted if the entry remains in the sbroker application env brokers , so this function should only be required to terminate a broker after it has been removed from brokers . Returns ok once the broker is terminated, otherwise {error, not_found} .","ref":"sbroker_user.html#terminate/1","title":"sbroker_user.terminate/1","type":"function"},{"doc":"List user brokers started in the sbroker application. Returns a list of brokers where Name is the sbroker:name() of the broker, Pid is the pid() or undefined , Type is worker and Modules is dynamic .","ref":"sbroker_user.html#which_brokers/0","title":"sbroker_user.which_brokers/0","type":"function"},{"doc":"This modules provides utility functions for overload protection and/or short circuiting calls to a process. It is designed for use with sbroker and sregulator processes using the sprotector_pie_meter meter. However any OTP process can use this module to do load balancing using the via naming format if the process is registered with and updates the sprotector_server . To use sprotector with via use names of the form {via, sprotector, {Broker, ask | ask_r}} . Where {Broker, ...} is a tuple containing pid() | atom() | {global, any()} | {via, module(), any()} | {atom(), node()} . The lookup will succeed if the approximate queue length is less than or equal to the minimum queue length or below the the maximum and the drop probability allows. Otherwise the call exits with reason drop . Therefore when combining with sbetter use format: {via, sprotector, {{via, sbetter, {..., ask | ask_r}, ask | ask_r}} . So the load balancing lookup is resolved first and wrapped by sprotector . It is not possible to locally look up the pid of a process with name {atom(), node()} if the node is not the local node. Therefore a registered name on another node is not supported for use with this module. If a chosen process is not local the call may exit with {badnode, node()} . If a chosen process is not registered with the sprotector_server the call may exit with {noprotector, pid()} . The sdropper_pie_meter will register with the server and update it using the PIE active queue management algorithm. However other methods can be used to register and update the sprotector_server . Registering with the sdropper_server must be done with sprotector_server:register/1 and not using start_link({via, sprotector, ...}, ...) . See also: sprotector_pie_meter , sprotector_server .","ref":"sprotector.html","title":"sprotector","type":"module"},{"doc":"Sends a message to a pid if not dropped by the min, max and drop probability of the chosen queue. Returns ok if the message is sent otherwise exits.","ref":"sprotector.html#send/2","title":"sprotector.send/2","type":"function"},{"doc":"Lookup a pid and possibly drop the request depending on the min, max and drop probability of the chosen queue. If no process is associated with the process returns undefined .","ref":"sprotector.html#whereis_name/1","title":"sprotector.whereis_name/1","type":"function"},{"doc":"","ref":"sprotector.html#t:process/0","title":"sprotector.process/0","type":"type"},{"doc":"Registers the process with and updates the sprotector_server using the &quot;basic&quot; PIE active queue management using approximate queue sojourn times. sprotector_pie_meter can be used as a sbroker_meter in a sbroker or a sregulator . It will provide a short circuiter that will drop requests without messaging the broker or regulator with a probability using PIE for the ask and ask_r queue when the message queue length is approximately above a minimum and all requests when it is approximately above a maximum. Its argument, spec() , is of the form: \#{ ask =&gt; \#{ target =&gt; AskTarget : : non_neg_integer ( ) , % default: 100 interval =&gt; AskInterval : : pos_integer ( ) } , % default: 1000 ask_r =&gt; \#{ target =&gt; AskRTarget : : non_neg_integer ( ) , % default: 100 interval =&gt; AskRInterval : : pos_integer ( ) } , % default: 1000 update =&gt; Update : : pos_integer ( ) , % default: 100 min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } . % default: infinity AskTarget is the target delay in milliseconds (defaults to 100 ) for the ask queue and AskInterval is the initial interval in milliseconds (defaults to 1000 ) before the first drop when the process's message queue is above the minimum size Min (defaults to 0 ) and below the maximum size Max (defaults to infinity). `AskRTarget and AskRInterval are equivalent for the ask_r queue. Update is the interval between updating the drop probability (defaults to 100 ). A person perceives a response time of 100 milliseconds or less as instantaneous, and feels engaged with a system if response times are 1000 milliseconds or less. Therefore it is desirable for a system to respond within 1000 milliseconds as a worst case (upper percentile response time) and ideally to respond within 100 milliseconds (target response time). Thus the default target is 100 milliseconds and the default is interval 1000 milliseconds. See also: sprotector , sprotector_server .","ref":"sprotector_pie_meter.html","title":"sprotector_pie_meter","type":"module"},{"doc":"","ref":"sprotector_pie_meter.html#t:spec/0","title":"sprotector_pie_meter.spec/0","type":"type"},{"doc":"Server for storing the ask and ask_r queue min, max and drop probabilities for overload protection and short circuiting for a process with sprotector .","ref":"sprotector_server.html","title":"sprotector_server","type":"module"},{"doc":"Change the queue minimum to Min and maximum to Max , and update the queue length to Len and the drop probabilities to AskDrop and AskRDrop . This function is an atomic. Returns true if the values were changed/updated, or false if Pid is not registered with the server.","ref":"sprotector_server.html#change/6","title":"sprotector_server.change/6","type":"function"},{"doc":"Register the local process Pid with the server with minimum message queue length Min and maximum message queue length Max . Lookup requests with sprotector will drop requests when above Max or with probabilities set by update/4 if above Min . Returns true if the process is successfully registered, or false if already registered. A process must be registered to use update/4 . Initial length and drop probabilites are set to 0 and 0.0 . The server will synchronously link to the Pid .","ref":"sprotector_server.html#register/3","title":"sprotector_server.register/3","type":"function"},{"doc":"Unregister the process Pid with the server. The server will synchronously unlink from Pid .","ref":"sprotector_server.html#unregister/1","title":"sprotector_server.unregister/1","type":"function"},{"doc":"Update the queue length ( Len ), and ask and ask_r drop probabilities ( AskDrop and AskRDrop ) for Pid . Len must be an integer greater than or equal to 0 . AskDrop and AskRDrop should be floats, values below 0.0 are rounded to 0.0 and above 1.0 to 1.0 . Returns true if the values were updated, or false if Pid is not registered with the server.","ref":"sprotector_server.html#update/4","title":"sprotector_server.update/4","type":"function"},{"doc":"This modules provides utility functions for basic load balancing based on choosing a random process. It is designed for use with OTP behaviour messaging using via names, e.g. {via, srand, {Process,...}} . The third element, {Process,...} , is a tuple containing pids ( pid() ) and/or process names ( atom() , {global, any()} , {via, module(), any()} or {atom(), node()} ). An element is chosen randomly, if the element is a pid() it is returned, otherwise the pid() of the process name is looked up. It is not possible to locally look up the pid of a process with name {atom(), node()} if the node is not the local node. Therefore a registered name on another node is not supported for use with this module.","ref":"srand.html","title":"srand","type":"module"},{"doc":"Send a message to one element, selected randomly, in a tuple of process names. Returns ok if the element chosen is a pid() . a locally registered name on another node, or a process is associated with the name. Otherwise exits.","ref":"srand.html#send/2","title":"srand.send/2","type":"function"},{"doc":"Lookup the pid or process name of one element, selected randomly, in a tuple of process names. If no process is associated with the name returns undefined .","ref":"srand.html#whereis_name/1","title":"srand.whereis_name/1","type":"function"},{"doc":"This module provides a job regulator for controlling the level of concurrency of processes carrying out a task. A process requests permission to run and is queued until it is allowed to begin. Once the task is complete the process informs the regulator that is is done. Alternatively the process can ask if it can continue running and gains priority over any queued processes. The queue is managed using an sbroker_queue callback module, and the level of concurrency by an sregulator_valve callback module. The message queue delay and processing delay are monitorred by an sbroker_meter . The main function to ask to begin is ask/1 , which blocks until the request is accepted or the queue drops the request. done/3 is then called after the task has finished or continue/2 to continue. A regulator requires a callback module to be configured, in a similar way to a supervisor's children are specified. The callback modules implements one callback, init/1 , with single argument Args . init/1 should return {ok, {QueueSpec, ValveSpec, [MeterSpec]}} or ignore . QueueSpec is the sbroker_queue specification, ValveSpec is the sregulator_valve specification and MeterSpec is a sbroker_meter specification. There can be any number of meters but a meter module can only be included once. All three take the same format: {Module, Args} , where Module is the callback module and Args the arguments term for the module. In the case of ignore the regulator is not started and start_link returns ignore . As the callback modules are defined in the init/1 callback a regulator supports the dynamic modules supervisor child specification. For example: - module ( sregulator_example ) . - behaviour ( sregulator ) . - export ( [ start_link / 0 ] ) . - export ( [ ask / 0 ] ) . - export ( [ continue / 1 ] ) . - export ( [ done / 1 ] ) . - export ( [ init / 1 ] ) . start_link ( ) -&gt; sregulator : start_link ( { local , ? MODULE } , ? MODULE , [ ] , [ ] ) . ask ( ) -&gt; case sregulator : ask ( ? MODULE ) of { go , Ref , _ , _ , _ } -&gt; { ok , Ref } ; { drop , _ } -&gt; { error , dropped } end . continue ( Ref ) -&gt; case sregulator : continue ( ? MODULE , Ref ) of { go , Ref , _ , _ , _ } -&gt; { ok , Ref } ; { done , _ } -&gt; { error , dropped } ; { not_found , _ } -&gt; { error , not_found } end . done ( Ref ) -&gt; sregulator : done ( ? MODULE , Ref ) . init ( [ ] ) -&gt; QueueSpec = { sbroker_codel_queue , \#{ } } , ValveSpec = { sregulator_open_valve , \#{ } } , MeterSpec = { sbroker_overload_meter , \#{ alarm =&gt; { overload , ? MODULE } } } , { ok , { QueueSpec , ValveSpec , [ MeterSpec ] } } .","ref":"sregulator.html","title":"sregulator","type":"behaviour"},{"doc":"Send a run request to the regulator, Regulator . Returns {go, Ref, RegulatorPid, RelativeTIme, SojournTime} on successfully being allowed to run or {drop, SojournTime} . Ref is the lock reference, which is a reference() . RegulatorPid is the pid() of the regulator process. RelativeTime is the time difference between when the request was sent and the message that opened the regulator's valve was sent. SojournTime is the approximate time spent in both the regulator's message queue and internal queue. RelativeTime represents the SojournTime without the overhead of the regulator. The value measures the queue congestion without being effected by the load of the regulator or node. If RelativeTime is positive, the request was enqueued in the internal queue awaiting a message to open the value that was sent approximately RelativeTime ater this request was sent. Therefore SojournTime minus RelativeTime is the latency, or overhead, of the regulator. If RelativeTime is negative, the regulator's valve was opened by a message sent abs(RelativeTime) before this request. Therefore SojournTime is the latency, or overhead, of the regulator. If RelativeTime is 0 , the request was sent at approximately the same as the message that open the regulator's valve.","ref":"sregulator.html#ask/1","title":"sregulator.ask/1","type":"function"},{"doc":"Monitor the regulator and send an asynchronous run request. Returns {await, Tag, Process} . Tag is a monitor reference() that uniquely identifies the reply containing the result of the request. Process is the pid() of the regulator or {atom(), node()} if the regulator is registered locally on a different node. The reply is of the form {Tag, Msg} where Msg is either {go, Ref, RegulatorPid, RelativeTime, SojournTime} or {drop, SojournTime} . Ref is the lock reference, which is a reference() . RegulatorPid is the pid() of the regulator process. RelativeTime is the time difference between when the request was sent and the message that opened the regulator's valve was sent. SojournTime is the approximate time spent in both the regulator's message queue and internal queue. Multiple asynchronous requests can be made from a single process to a regulator and no guarantee is made of the order of replies. A process making multiple requests can reuse the monitor reference for subsequent requests to the same regulator process ( Process ) using async_ask/2 . If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: async_ask/2 , cancel/2 .","ref":"sregulator.html#async_ask/1","title":"sregulator.async_ask/1","type":"function"},{"doc":"Send an asynchronous run request using tag, Tag . Returns {await, Tag, Process} . To is a tuple containing the process, pid() , to send the reply to and Tag , any() , that idenitifes the reply containing the result of the request. Process is the pid() of the regulator or {atom(), node()} if the regulator is registered locally on a different node. Otherwise this function is equivalent to async_ask/1 . See also: async_ask/1 , cancel/2 .","ref":"sregulator.html#async_ask/2","title":"sregulator.async_ask/2","type":"function"},{"doc":"Await the response to an asynchronous request idenitifed by Tag . Exits if a response is not received after Timeout milliseconds. Exits if a DOWN message is received with reference Tag . See also: async_ask/1 , async_ask/2 .","ref":"sregulator.html#await/2","title":"sregulator.await/2","type":"function"},{"doc":"Equivalent to cancel(Regulator, Tag, infinity) .","ref":"sregulator.html#cancel/2","title":"sregulator.cancel/2","type":"function"},{"doc":"Cancel an asynchronous request. Returns the number of cancelled requests or false if no requests exist with tag Tag . In the later case a caller may wish to check is message queue for an existing reply. See also: async_ask/1 , async_ask/2 .","ref":"sregulator.html#cancel/3","title":"sregulator.cancel/3","type":"function"},{"doc":"Update the valve in the regulator without waiting for the regulator to handle the update. Value is an integer() . Returns ok .","ref":"sregulator.html#cast/2","title":"sregulator.cast/2","type":"function"},{"doc":"Equivalent to change_config(Regulator, infinity) .","ref":"sregulator.html#change_config/1","title":"sregulator.change_config/1","type":"function"},{"doc":"Change the configuration of the regulator. Returns ok on success and {error, Reason} on failure, where Reason is the reason for failure. The regulators calls the init/1 callback to get the new configuration. If init/1 returns ignore the config does not change.","ref":"sregulator.html#change_config/2","title":"sregulator.change_config/2","type":"function"},{"doc":"Send a request to continue running using an existing lock reference, Ref . The request is not queued. Returns {go, Ref, RegulatorPid, RelativeTime, SojournTime} on successfully being allowed to run, {stop, SojournTime} when the process should stop running or {not_found, SojournTime} when the lock reference does not exist on the regulator. Ref is the lock reference, which is a reference() . RegulatorPid is the pid() of the regulator process. RelativeTime is the time difference between when the request was sent and the message that opened the regulator's valve was sent. SojournTime is the approximate time spent in the regulator's message queue. If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. In this situation the Ref is still a valid lock on the regulator. See also: ask/1 .","ref":"sregulator.html#continue/2","title":"sregulator.continue/2","type":"function"},{"doc":"Cancels an asynchronous request. Returns ok without waiting for the regulator to cancel requests. See also: cancel/3 .","ref":"sregulator.html#dirty_cancel/2","title":"sregulator.dirty_cancel/2","type":"function"},{"doc":"Asynchronously inform the regulator the process has finished running and should release the lock, Ref . Returns ok without waiting for the regulator to release the lock. See also: done/3 .","ref":"sregulator.html#dirty_done/2","title":"sregulator.dirty_done/2","type":"function"},{"doc":"Equivalent to done(Regulator, Ref, infinity) .","ref":"sregulator.html#done/2","title":"sregulator.done/2","type":"function"},{"doc":"Inform the regulator the process has finished running and release the lock, Ref . Returns {stop, SojournTime} if the regulator acknowledged the process has stopped running or {not_found, SojournTime} if the lock reference, Ref , does not exist on the regulator. SojournTime is the time the request spent in the regulator's message queue. See also: ask/1 .","ref":"sregulator.html#done/3","title":"sregulator.done/3","type":"function"},{"doc":"Send a run request to the regulator, Regulator . If not immediately allowed to run the request is converted to an async_ask/1 . Returns {go, Ref, RegulatorPid, RelativeTime, SojournTime} on successfully being allowed to run or {await, Tag, RegulatorPid} . Ref is the lock reference, which is a reference() . RegulatorPid is the pid() of the regulator process. RelativeTime is the time difference between when the request was sent and the message that opened the regulator's valve was sent. SojournTime is the approximate time spent in the regulator's message queue. Tag is a monitor reference, as returned by async_ask/1 . If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: async_ask/1 , nb_ask/1 .","ref":"sregulator.html#dynamic_ask/1","title":"sregulator.dynamic_ask/1","type":"function"},{"doc":"","ref":"sregulator.html#c:init/1","title":"sregulator.init/1","type":"callback"},{"doc":"Equivalent to len(Regulator, infinity) .","ref":"sregulator.html#len/1","title":"sregulator.len/1","type":"function"},{"doc":"Get the length of the internal queue in the regulator, Regulator .","ref":"sregulator.html#len/2","title":"sregulator.len/2","type":"function"},{"doc":"Send a run request to the regulator, Regulator , but do not enqueue the request if not immediately allowed to run. Returns {go, Ref, RegulatorPid, RelativeTime, SojournTime} on successfully being allowed to run or {drop, SojournTime} . Ref is the lock reference, which is a reference() . RegulatorPid is the pid() of the regulator process. RelativeTime is the time difference between when the request was sent and the message that opened the regulator's valve was sent. SojournTime is the approximate time spent in the regulator's message queue. If the request is dropped when using via module sprotector returns {drop, 0} and does not send the request. See also: ask/1 .","ref":"sregulator.html#nb_ask/1","title":"sregulator.nb_ask/1","type":"function"},{"doc":"Equivalent to size(Regulator, infinity) .","ref":"sregulator.html#size/1","title":"sregulator.size/1","type":"function"},{"doc":"Get the number of processes holding a lock with the regulator, Regulator .","ref":"sregulator.html#size/2","title":"sregulator.size/2","type":"function"},{"doc":"Starts a regulator with callback module Module and argument Args , and regulator options Opts . Opts is a proplist and supports debug , timeout and spawn_opt used by gen_server and gen_fsm . read_time_after sets the number of requests when a cached time is stale and the time is read again. Its value is non_neg_integer() or infinity and defaults to 16 . See also: gen_server:start_link/3 .","ref":"sregulator.html#start_link/3","title":"sregulator.start_link/3","type":"function"},{"doc":"Starts a regulator with name Name , callback module Module and argument Args , and regulator options Opts . See also: start_link/3 .","ref":"sregulator.html#start_link/4","title":"sregulator.start_link/4","type":"function"},{"doc":"","ref":"sregulator.html#timeout/1","title":"sregulator.timeout/1","type":"function"},{"doc":"Equivalent to update(Regulator, Value, infinity) .","ref":"sregulator.html#update/2","title":"sregulator.update/2","type":"function"},{"doc":"Synchronously update the valve in the regulator. Value is an integer() and Timeout is the timout, timeout() , to wait in milliseconds for the regulator to reply to the update. Returns ok .","ref":"sregulator.html#update/3","title":"sregulator.update/3","type":"function"},{"doc":"","ref":"sregulator.html#t:debug_option/0","title":"sregulator.debug_option/0","type":"type"},{"doc":"","ref":"sregulator.html#t:handler_spec/0","title":"sregulator.handler_spec/0","type":"type"},{"doc":"","ref":"sregulator.html#t:name/0","title":"sregulator.name/0","type":"type"},{"doc":"","ref":"sregulator.html#t:regulator/0","title":"sregulator.regulator/0","type":"type"},{"doc":"","ref":"sregulator.html#t:start_option/0","title":"sregulator.start_option/0","type":"type"},{"doc":"","ref":"sregulator.html#t:start_return/0","title":"sregulator.start_return/0","type":"type"},{"doc":"Implements a valve which increases its size based on CoDel (Controlling Queue Delay). sregulator_codel_valve can be used as the sregulator_valve in a sregulator . It will provide a valve that increases in size in decreasing intervals while updates remain below a target (based on CoDel) between the minimum and maximum capacity. Its argument, spec() , is of the form: \#{ target =&gt; Target : : integer ( ) , % default: 100 interval =&gt; Interval : : pos_integer ( ) , % default: 1000 min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Target is the target relative value in milliseconds. Interval is the initial interval in milliseconds. The valve will open when updates remain below the target (in native time units) for an interval. Each consecutive interval is smaller than the last until an update above the target is received. The valve is always open when below the minimum and always closed once it reaches the maximum. This valve tries to enforce a minimum level of concurrency and will grow while a relevant sbroker_queue is moving quickly - up to a maximum. Therefore this valves expects the updates to be from a sregulator_update_meter . The algorithm used in this valve is similar to sbroker_codel_queue , except designed to keep the relevant queue slow (but not too slow) instead of fast. Therefore trying to ensure the counter party to the queue is always fast without using too many resources. This works by increasing the concurrency or number of requests when the queue is consistently fast and remaining static when the queue is slow. Therefore forcing the queue to be slightly slow. This valve is designed to be used a sbroker_codel_queue with the same Interval and Target s that are between 10% and 20% of the Interval . The target range is suggested due to the observation in the CoDel paper that the queue goes from to fast to slow over this target range. Higher targets result in heavily congested queues and wasted resources. A suggested initial Interval is the 95% percentile of the time it takes to stop a task and restart, as this is equivalent to the round trip when a packet is dropped and resent to rejoin the queue in the paper. Decreasing the target of the valve makes it more resistant to bursts and reducing the target of the queue will increase the rate of shrinking when load decreases. This fulfils the general desire to increase resouce usage as late as possible and decrease resource usage as early as possible. If the queue's target is significantly lower than valve's this may lead to churn as the queue and valve may act against each other. Also if the minimum is too high the queue may drop the requests only for the valve to allow immediate enqueues. More investigation needs to be done on suitable parameters.","ref":"sregulator_codel_valve.html","title":"sregulator_codel_valve","type":"module"},{"doc":"","ref":"sregulator_codel_valve.html#t:spec/0","title":"sregulator_codel_valve.spec/0","type":"type"},{"doc":"Implements a simple valve with maximum capacity. sregulator_open_value can be used as the sregulator_valve in a sregulator . It will provide a value that is always open up to a maximum capacity. Its argument, spec() is of the form: \#{ max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Max is the maximum number of concurrent tasks the valve will allow to run (defaults to infinity ). The valve remains open up to the maximum and then closes. It ignores any updates.","ref":"sregulator_open_valve.html","title":"sregulator_open_valve","type":"module"},{"doc":"","ref":"sregulator_open_valve.html#t:spec/0","title":"sregulator_open_valve.spec/0","type":"type"},{"doc":"Implements a valve with a rate limit between a minimum and maximum capacity. sregulator_rate_value can be used as the sregulator_valve in a sregulator . It will provide a valve that limits the rate of tasks when between a minimum and maximum capacity. Its argument, spec() , is of the form: \#{ limit =&gt; Limit : : non_neg_integer ( ) , % default: 100 interval =&gt; Interval : : pos_integer ( ) , % default: 1000 min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } . % default: infinity Limit is the number of new tasks (defaults to 100 ) that can run when the number of concurrent tasks is at or above the minimum capacity, Min (defaults to 0 ), and below the maximum capacity, Max (defaults to infinity ). The limit is temporarily reduced by 1 for Interval milliseconds (defaults to 1000 ) after a task is done and the capacity is above Min . Also the limit is restricted to 0 for Interval milliseconds after the valve is started. This ensures that no more than Limit tasks can run above the minimum capacity for any time interval of Interval milliseconds, even if the sregulator is restarted. This valve ignores any updates.","ref":"sregulator_rate_valve.html","title":"sregulator_rate_valve","type":"module"},{"doc":"","ref":"sregulator_rate_valve.html#t:spec/0","title":"sregulator_rate_valve.spec/0","type":"type"},{"doc":"Implements a valve which increases its size when an update is below a target. sregulator_relative_value can be used as the sregulator_valve in a sregulator . It will provide a valve that increases in size when an update is below a target valve between the minimum and maximum capacity. Its argument, spec() , is of the form: \#{ target =&gt; Target : : integer ( ) , % default: 100 min =&gt; Min : : non_neg_integer ( ) , % default: 0 max =&gt; Max : : non_neg_integer ( ) | infinity } % default: infinity Target is the target relative value in milliseconds (defaults to 100 ). The valve will open when an update below the target (in native time units) is received if between the the minimum, Min (defaults to 0 ), and the maximum, Max (defaults to infinity ). Once opened by an update the valve remains open until the concurrency level increases by 1 or an update greater than the target is received. The valve is always open when below the minimum and always closed once it reaches the maximum. This valve tries to enforce a minimum level of concurrency and will grow while a relevant sbroker_queue is moving quickly - up to a maximum. Therefore this valve expects the updates to be from a sregulator_update_meter . By using a positive target RelativeTime of an sbroker queue, a pool of workers can grow before the queue is empty. Therefore preventing or delaying the situation where the counter party client processes have to wait for a worker. By using a negative target RelativeTime of an sbroker queue, a pool of expensive resources can delay growth until required.","ref":"sregulator_relative_valve.html","title":"sregulator_relative_valve","type":"module"},{"doc":"","ref":"sregulator_relative_valve.html#t:spec/0","title":"sregulator_relative_valve.spec/0","type":"type"},{"doc":"Sets an alarm when the regulator's valve is slow to get a match for an interval. sregulator_underload_meter can be used in as a sbroker_meter in a sregulator . It will set a SASL alarm_handler alarm when the regulator's valve is slow to get a match for an interval and clear it once the valve gets matches fast for an interval. Its argument, spec() , is of the form: \#{ alarm =&gt; Alarm : : any ( ) , % default: {underload, self()} target =&gt; Target : : integer ( ) , % default: 100 interval =&gt; Interval : : pos_integer ( ) } . % default: 1000 Alarm is the alarm_handler alarm that will be set/cleared by the meter (defaults to {underload, self()} ). Target is the target relative time for the valve to get a match (defaults to 100 ). Interval is the interval in milliseconds (defaults to 1000 ) that the valve must be above the target for the alarm to be set and below the target for the alarm to be cleared. The description of the alarm is {valve_slow, self()} . This meter is only intended for a sregulator because a sregulator_valve will remain open when processes that should be available are not sending requests and can not do anything to correct this. Whereas a sbroker can not distinguish between one queue receiving too many requests or the other too few. In either situation the congested sbroker_queue would drop requests to correct the imbalance, causing a congestion alarm to be cleared very quickly.","ref":"sregulator_underload_meter.html","title":"sregulator_underload_meter","type":"module"},{"doc":"","ref":"sregulator_underload_meter.html#t:spec/0","title":"sregulator_underload_meter.spec/0","type":"type"},{"doc":"Updates a list of regulators with the relative time of either queue. sregulator_update_meter can be used as a sbroker_meter in a sbroker or a sregulator . It will update a list of regulators with the relative time (in native time units) of a specified queue at random intervals, ignoring any regulators that are not alive. Its argument, spec() , is of the form: [ { Regulator : : sregulator : regulator ( ) , Queue : : ask | ask_r , Config : : \#{ update =&gt; Update : : pos_integer ( ) } } , . . . ] . Regulator is a regulator process to update with the approximate relative time of queue Queue with updates uniformly distributed from 0.5 * Update to 1.5 * Update milliseconds (defaults to 100 ). This random interval is used to prevent synchronisation of update messages and their side effects, see reference. See also: sregulator .","ref":"sregulator_update_meter.html","title":"sregulator_update_meter","type":"module"},{"doc":"","ref":"sregulator_update_meter.html#t:spec/0","title":"sregulator_update_meter.spec/0","type":"type"},{"doc":"This module provides helpers for managing sregulator processes that are automatically started in the sbroker supervision tree. sregulator processes can be automatically started when the sbroker application starts by setting the sbroker application env regulators . It is a list of regulator names and specifications, of the form: [ { Name : : sregulator : name ( ) , Spec : : { QueueSpec : : sregulator : handler_spec ( ) , ValveSpec : : sregulator : handler_spec ( ) , [ MeterSpec : : sregulator : handler_spec ( ) ] } } ] Name is the name of the regulator and each regulator will be registered using its name, e.g. {local, my_regulator} . Spec is the specification for the sregulator , which is equivalent to returning {ok, Spec} from the init/1 callback: QueueSpec is the queue spec, ValveSpec is the valve spec and MeterSpec is a meter spec. Starting regulators in the sbroker application allows multiple applications, to access a sregulator or to isolate the regulator from errors in an application.","ref":"sregulator_user.html","title":"sregulator_user","type":"module"},{"doc":"Call sregulator:change_config/1 on all regulators started in the sbroker application. This function can be used to reconfigure all regulators that are already started after the sbroker application env regulators is changed. Returns a list of failed changes, where Name is the sregulator:name() of the regulator and Reason is the reason.","ref":"sregulator_user.html#change_config/0","title":"sregulator_user.change_config/0","type":"function"},{"doc":"Delete a regulator with name, Name . The regulator is deleted in the sbroker application's supervision tree. Regulators are automatically started when the sbroker is started, and might be restarted if the entry remains in the sbroker application env regulators , so this function should only be required to delete a regulator after it has been removed from regulators . Returns ok on successfully deleting the regulator, otherwise {error, Reason} where Reason is reason for the error.","ref":"sregulator_user.html#delete/1","title":"sregulator_user.delete/1","type":"function"},{"doc":"Restart a regulator with name, Name . The regulator is restarted in the sbroker application's supervision tree using configuration from the sbroker application env regulators . Regulators are automatically started when the sbroker is started so this function should only be required if a regulator is terminated. Returns {ok, Pid} on starting the regulator, where Pid is the pid() of the regulator, {ok, undefined} if a configuration for Name does not exist in regulators or {error, Reason} if the regulator fails to start with reason Reason .","ref":"sregulator_user.html#restart/1","title":"sregulator_user.restart/1","type":"function"},{"doc":"Starts a regulator with name, Name . The regulator is started in the sbroker application's supervision tree using configuration from the sbroker application env regulators . Regulators are automatically started when the sbroker application is started so this function should only be required if a regulator is added to the configuration. Returns {ok, Pid} on starting the regulator, where Pid is the pid() of the regulator, {ok, undefined} if a configuration for Name does not exist in regulators or {error, Reason} if the regulator fails to start with reason Reason .","ref":"sregulator_user.html#start/1","title":"sregulator_user.start/1","type":"function"},{"doc":"Terminate a regulator with name, Name . The regulator is terminated in the sbroker application's supervision tree. Regulators are automatically started when the sbroker is started, and might be restarted if the entry remains in the sbroker application env regulators , so this function should only be required to terminate a regulator after it has been removed from regulators . Returns ok once the regulator is terminated, otherwise {error, not_found} .","ref":"sregulator_user.html#terminate/1","title":"sregulator_user.terminate/1","type":"function"},{"doc":"List user regulators started in the sbroker application. Returns a list of regulators where Name is the sregulator:name() of the regulator, Pid is the pid() or undefined , Type is worker and Modules is dynamic .","ref":"sregulator_user.html#which_regulators/0","title":"sregulator_user.which_regulators/0","type":"function"},{"doc":"Behaviour for implementing values for sregulator . A custom valve must implement the sregulator_valve behaviour. The first callback is init/3 , which starts the valve: - callback init ( InternalMap : : internal_map ( ) , Time : : integer ( ) , Args : : any ( ) ) -&gt; { Status : : open | closed , State : : any ( ) , TimeoutTime : : integer ( ) | infinity } . InternalMap is the internal map of running processes, it is a map() with monitor reference() keys and pid() value where the monitor is that of the process. Time is the time, in native time units, of the valve at creation. Some other callbacks will receive the current time of the valve as the second last argument. It is monotically increasing, so subsequent calls will have the same or a greater time. Args is the arguments for the valve. It can be any term. Status is whether the valve accepts new requests or not. The handle_ask/4 callback to handle a request will only be called when the previous callback returns open . State is the state of the queue and used in the next call. TimeoutTime represents the next time a valve wishes to call handle_timeout/2 to change status. If a message is not received the timeout should occur at or after TimeoutTime . The time must be greater than or equal to Time . If a valve does not require a timeout then TimeoutTime should be infinity . When allowing a request to run, handle_ask/4 : - callback handle_ask ( Ref : : reference ( ) , Pid : : pid ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { go , Open , Status : : open | closed , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Ref is a monitor reference of the sender, Pid , as in the InternalMap in init/3 . Open is the time the valve opened to allow this request. The other variables are equivalent to those in init/3 , with NState being the new state. When a request has finished, handle_done/3 : - callback handle_done ( Ref : : reference ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { Result : : done | error , Status : : open | closed , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Result is done when the Ref is known by the valve and is removed, if Ref is not found in the valve it is error . The other variables are equivalent to those in handle_ask/4 . When a request is asking to continue, handle_continue/3 : -callback handle_continue(Ref :: reference(), Time :: integer(), State :: any()) -&gt; {Result :: go, Open :: integer(), , Status :: open | closed, NState :: any(), TimeoutTime :: integer() | infinity} | {Result :: done | error, Status :: open | closed, NState :: any(), TimeoutTime :: integer() | infinity}. ''' Result is go if Ref is known by the valve and is allowed to continue, if Ref is removed from the valve it is done and if Ref is not found in the valve it is error . The other variables are equivalent to those in handle_ask/3 . When handling a message, handle_info/3 : - callback handle_info ( Msg : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { Status : : open | closed , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . Msg is the message, and may be intended for another callback. The other variables are equivalent to those in init/3 , with NState being the new state. When a timeout occurs, handle_timeout/2 : - callback handle_timeout ( Time : : integer ( ) , State : : any ( ) ) -&gt; { Status : : open | closed , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/3 , with NState being the new state. When changing the state due to a code change, code_change/4 : - callback code_change ( OldVsn : : any ( ) , Time : : integer ( ) , State : : any ( ) , Extra : : any ( ) ) -&gt; { NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . On an upgrade OldVsn is version the state was created with and on an downgrade is the same form except {down, OldVsn} . OldVsn is defined by the vsn attribute(s) of the old version of the callback module. If no such attribute is defined, the version is the checksum of the BEAM file. Extra is from {advanced, Extra} in the update instructions. The other variables are equivalent to those in init/3 , with NState being the new state. When changing the configuration of a valve, config_change/4 : - callback config_change ( Args : : any ( ) , Time : : integer ( ) , State : : any ( ) ) -&gt; { Status : : open | closed , NState : : any ( ) , TimeoutTime : : integer ( ) | infinity } . The variables are equivalent to those in init/3 , with NState being the new state. When returning the number of tasks monitored by the valve, size/1 : - callback size ( State : : any ( ) ) -&gt; Size : : non_neg_integer ( ) . State is the current state of the valve and Size is the number of tasks being monitorred. This callback must be idempotent and not change the status of the valve. When returning the open time for the time the valve opened or will open if no side effects before then, open_time/1 : - callback open_time ( State : : any ( ) ) -&gt; OpenTime : : integer ( ) | closed . State is the current state of the valve and OpenTime is the open time of the valve, if closed and will not open without a side effect then closed . When cleaning up the valve, terminate/2 : - callback terminate ( Reason : : sbroker_handlers : reason ( ) , State : : any ( ) ) -&gt; InternalMap : : internal_map ( ) . Reason is stop if the valve is being shutdown, change if the valve is being replaced by another valve, {bad_return_value, Return} if a previous callback returned an invalid term or {Class, Reason, Stack} if a previous callback raised an exception. State is the current state of the valve. InternalMap is the same as init/3 and is passed to the next valve if Reason is change . The process controlling the valve may not be terminating with the valvee and so terminate/2 should do any clean up required.","ref":"sregulator_valve.html","title":"sregulator_valve","type":"behaviour"},{"doc":"","ref":"sregulator_valve.html#c:code_change/4","title":"sregulator_valve.code_change/4","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:config_change/3","title":"sregulator_valve.config_change/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_ask/4","title":"sregulator_valve.handle_ask/4","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_continue/3","title":"sregulator_valve.handle_continue/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_done/3","title":"sregulator_valve.handle_done/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_info/3","title":"sregulator_valve.handle_info/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_timeout/2","title":"sregulator_valve.handle_timeout/2","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:handle_update/3","title":"sregulator_valve.handle_update/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:init/3","title":"sregulator_valve.init/3","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:open_time/1","title":"sregulator_valve.open_time/1","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:size/1","title":"sregulator_valve.size/1","type":"callback"},{"doc":"","ref":"sregulator_valve.html#c:terminate/2","title":"sregulator_valve.terminate/2","type":"callback"},{"doc":"","ref":"sregulator_valve.html#t:internal_map/0","title":"sregulator_valve.internal_map/0","type":"type"},{"doc":"This modules provides utility functions for basic load balancing based on the scheduler id of the calling process. It is designed for use with OTP behaviour messaging using via names, e.g. {via, sscheduler, {Process,...}} . The third element, {Process,...} , is a tuple containing pids ( pid() ) and/or process names ( atom() , {global, any()} , {via, module(), any()} or {atom(), node()} ). An element is chosen based on the scheduler id, if the element is a pid() it is returned, otherwise the pid() of the process name is looked up. It is not possible to locally look up the pid of a process with name {atom(), node()} if the node is not the local node. Therefore a registered name on another node is not supported for use with this module.","ref":"sscheduler.html","title":"sscheduler","type":"module"},{"doc":"Send a message to one element, selected based on the scheduler id, in a tuple of process names. Returns ok if the element chosen is a pid() . a locally registered name on another node, or a process is associated with the name. Otherwise exits.","ref":"sscheduler.html#send/2","title":"sscheduler.send/2","type":"function"},{"doc":"Lookup the pid or process name of one element, selected based on the scheduler id, in a tuple of process names. If no process is associated with the name returns undefined .","ref":"sscheduler.html#whereis_name/1","title":"sscheduler.whereis_name/1","type":"function"},{"doc":"sbroker is a library that provides the building blocks for creating a pool and/or a load regulator. The main goals of the library are to minimise upper percentile latency by smart queuing, easily change the feature set live with minimal changes, easily inspect a live system and provide confidence with property based testing.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add a broker to the sbroker application env brokers and it will be started when the application starts. Below we use a CoDel queue for the ask side, a timeout queue for the ask_r side and no meters. Processes then call sbroker:ask/1 and sbroker:ask_r to find a match. A process calling sbroker:ask/1 will only match with a process that calls sbroker:ask_r and vice versa. ok = application : load ( sbroker ) , Broker = broker , Brokers = [ { { local , Broker } , { { sbroker_codel_queue , \#{ } } , { sbroker_timeout_queue , \#{ } } , [ ] } } ] , ok = application : set_env ( sbroker , brokers , Brokers ) , { ok , _ } = application : ensure_all_started ( sbroker ) . Pid = spawn_link ( fun ( ) -&gt; { go , Ref , _ , _ , _ } = sbroker : ask_r ( Broker ) end ) , { go , Ref , Pid , _ , _ } = sbroker : ask ( Broker ) . Matches can also be requested without queuing, asynchronously or using a dynamic approach that is synchronous but becomes asynchronous if a match isn't immediately available.","ref":"readme.html#example","title":"Overview - Example","type":"extras"},{"doc":"The minimum OTP version supported is 18.0. The sasl application is required to start the sbroker application. The sasl error_logger handler can be disabled by setting the sasl application env sasl_error_logger to false .","ref":"readme.html#requirements","title":"Overview - Requirements","type":"extras"},{"doc":"For rebar3 add sbroker as a depencency in rebar.config : { deps , [ sbroker ] } . Other build tools may work if they support rebar3 dependencies but are not directly supported.","ref":"readme.html#installing","title":"Overview - Installing","type":"extras"},{"doc":"$ rebar3 ct ...","ref":"readme.html#testing","title":"Overview - Testing","type":"extras"},{"doc":"Documentation is hosted on hex: http://hexdocs.pm/sbroker/ . From overview.edoc (previous version) Sojourn Broker is an alternative to traditional pooling approaches, it focuses on the queues involved. Both clients and workers are explicitly enqueued into the relevant queues and a match occurs once both a client and a worker are queued. Both queues have many configuration options (see &quot;Smart Queues&quot; below) that can reconfigured live as part of a code update or config change in a release upgrade, or from the shell without dropping requests. There is a simple interface to match processes. One party calls sbroker:ask/1 and the counterparty sbroker:ask_r/1 . If a match is found both return {go, Ref, Pid, RelativeTime, SojournTime} . Ref is the transaction reference. Pid is the other process in the match, which can be changed to any term using sbroker:ask/2 and sbroker:ask_r/2 . SojournTime is the time spent waiting for a match and RelativeTime is difference between when the counterparty and caller sent their requests. If no match is found, returns {drop, SojournTime} . SojournTime and RelativeTime are in native time units to allow conversion to the unit of choice without loss of accuracy. However the time may not be read for every request so these values are not as accurate as the precision suggests. The time is read using erlang:monotonic_time/0 and so the minimum OTP version is 18.0. For more information on RelativeTime see &quot;Relative Time and Regulation&quot; below. Processes calling sbroker:ask/1 are matched with a process calling sbroker:ask_r/1 and vice versa. See sbroker for alternative functions to request a match, such as the asynchronous sbroker:async_ask/1 . === Usage === sbroker provides configurable queues defined by sbroker:handler_spec() s. A handler_spec() takes the form: { Module , Args } Module is an sbroker_queue callback module to queue. The following callback modules are provided: sbroker_drop_queue , sbroker_timeout_queue , sbroker_codel_queue and sbroker_fair_queue . Args is the argument passed to the callback module. Information about the different backends and their arguments are avaliable in the documentation. An sbroker is started using sbroker:start_link/3,4 : sbroker : start_link ( Module , Args , Opts ) . sbroker : start_link ( Name , Module , Args , Opts ) . The sbroker will call Module:init(Args) , which should return the specification for the sbroker : init ( _ ) -&gt; { ok , { AskQueueSpec , AskRQueueSpec , [ MeterSpec ] } } . AskQueueSpec is the handler_spec() for the queue containing processes calling ask/1 . The queue is referred to as the ask queue. Similarly AskRQueueSpec is the handler_spec() for the queue contaning processes calling ask_r/1 , and the queue is referred to as the ask_r queue. MeterSpec is a handler_spec() for a meter running on the broker. Meters are given metric information and are called when the time is updated, see sbroker_meter . The following sbroker_meter modules are provided: sbroker_overload_meter , sbetter_meter , sprotector_pie_meter , sregulator_update_meter and sregulator_underload_meter . For example: - module ( sbroker_example ) . - behaviour ( sbroker ) . - export ( [ start_link / 0 ] ) . - export ( [ init / 1 ] ) . start_link ( ) -&gt; sbroker : start_link ( ? MODULE , undefined , [ ] ) . init ( _ ) -&gt; QueueSpec = { sbroker_timeout_queue , \#{ timeout =&gt; 200 } } , { ok , { QueueSpec , QueueSpec , [ ] } } . sbroker_example:start_link/0 will start an sbroker with queues configured by QueueSpec . This configuration uses the sbroker_timeout_queue callback module which drops requests when they have been in the queue for longer than a time limit ( 200 milliseconds). To use this sbroker : { ok , Broker } = sbroker_example : start_link ( ) , Self = self ( ) , Pid = spawn_link ( fun ( ) -&gt; { go , _ Ref , Self , _ , _ } = sbroker : ask_r ( Broker ) end ) , { go , _ Ref , Pid , _ , _ } = sbroker : ask ( Broker ) . === Error Isolation === When a worker process holds a resource, especially sockets, it can be difficult or impossible to provide the guarantee to client processes that the resource will always be available when the worker is called. This can be achieved by creating the resource inside the worker's init/1 callback and terminating as soon as the resource is no longer available. Often this is not practical because the supervision tree would not withstand a resource worker constantly failuring but you want to handle the failure. For example, if a remote server went down. Therefore the worker must handle the error. Normally this involves backing off and retrying until the resouce is created. Usually this means that the worker must handle requests when the resource isn't available and client must handle the error when the resource isn't available. If the worker does backoff it is possible that a client gets unlucky gets a worker that doesn't have a resource when other workers are available that have a resource. It is also possible that the client calls the worker when a worker is busy creating the resource and has to wait for the worker to either create the resource or fail/time out and get an error. Sojourn broker tries to alleviate this issue by requiring the worker to choose when it is enqueued. Therefore only available workers or resources should be in the queue waiting for a client. This isolates the errors and allows the client to wait for a resource to become available. If a resource becomes unavailable while in the queue the worker can remove itself from the queue with sbroker:cancel/3 . A common pattern is as follows: client ( ) -&gt; case sbroker : ask ( sbroker_example ) of { go , Ref , { Resource , Pid } , _ , _ } -&gt; % stuff happens here using Resource, 3rd element set by counterparty Pid ! { Ref , done } , ok ; { drop , _ } -&gt; { error , drop } end . init ( ) -&gt; % create any resources or backoff and retry, e.g. open gen_tcp socket loop ( Resource ) . loop ( Resource ) -&gt; % use reverse ask call to counterparty case sbroker : ask_r ( sbroker_example , { Resource , Pid } ) of { go , GRef , Pid , _ , _ } -&gt; MRef = monitor ( process , Pid ) , receive { &#39;DOWN&#39; , MRef , _ , _ , _ } -&gt; % counterparty crashed, handle error before enqueuing again stop ( Resource ) ; { GRef , done } -&gt; % counterparty finished with resource demonitor ( MRef , [ flush ] ) , loop ( Resource ) after 5000 -&gt; % timeout if don&#39;t hear from counterparty demonitor ( MRef , [ flush ] ) , stop ( Resource ) end { drop , _ } -&gt; % dropped by queue stop ( Resource ) end . stop ( Resource ) -&gt; % clean up any resources init ( ) . Usually the looping worker/resource process will be an OTP process, e.g. a gen_server , and uses asynchronous queue requests using sbroker:async_r/2,3 . However if a resource becomes unavailable and workers are backing off then client requests won't match and will wait in the queue until they are dropped. In a simple timeout queue, like a gen_server:call/3 , this means waiting for the timeout and then failing. When an end user client is waiting in a queue it can not distinguish between complete unavailability of the resource or a slow/congested queue in front of the resource. Therefore queue congestion avoidance techniques in &quot;Smart Queues&quot; below can be used to avoid the problem. This may mean that the client waits for a very short period before failing, possibly allowing for the resource to become available. === Smart Queues === The primary goal of Sojourn Broker is to reduce upper tail latency. The first step to achieving this is by only queuing a request when ready to handle a match. Once in the queue the request has to wait for a match, which may not occur in a reasonable time if a resource is unavailable or there are a lot of other requests causing the queue to move slowly. The simplest approach is to limit the length of the queue and either prevent new requests joining the queue or drop the oldest request in the queue when the maximum is reached. The later can prevent head of the line blocking, which can be especially useful when newer requests overwrite the data from older requests. Unfortunately choosing a suitable limit can be difficult because some queues are short and slow and others are long and fast. This can mean that requests stay in the queue for a long time, or indefinitely if the resource is not available. The most common technique to avoid this is to add a timeout to the queue, see sbroker_timeout_queue , so requests have an upper bound on the time they can spend waiting for a match. When a timeout queue gets heavily congested the length of the queue in time, SojournTime , can approach this upper bound as all requests either timeout or get a match just before the timeout would occur because the request immediately before it timed out. A similar issues can occur when setting a queue size and dropping the oldest process at the maximum. Requests are either dropped for reaching the maximum size or get a match because the request immediately before it got dropped. This leads to every request taking approximately the time it takes to fill the queue. In both cases if requests are going to be dropped it would be better to drop them sooner, rather than later, so successful requests do not have to wait so long. Sojourn Broker provides two modern active queue managent algorithms to drop requests earlier that would be dropped later when using simpler strategies. Both are configured using a Target sojourn time and an Interval , where requests will only be dropped once the queue has been continuously above the target for the initial interval. After this point the active queue management will try to drop a suitable number of requests so that the queue remains near the target. The Interval value is should usually be in the 95%-99% percentile range of the time it would take the end user client to discover the request had been dropped and get a new request in the queue. The Target would then be 5%-10% of that value for the application to feel responsive to a client. One approach is to use the sbroker_codel_queue , which uses the Controlled Delay (CoDel) active queue management algorithm. The second approach is to use the sprotector_pie_meter , which uses the basic Proportional Integral controller Enchanced (PIE) algorithm. The CoDel queue will try to evenly but unpredictable space out drops so that dropped clients do not retry at the same time by dropping the oldest request. During big bursts this can lead to higher SojournTime values if a suitable queue size is not set because the dropping algorithm is trying to spread out the drops. CoDel reduces the interval between drops while the queue is above target. This means if the counterparties are not trying to match, e.g. resources can't be created, then the drop interval will become very small and requests will be dropped frequently. The PIE meter tries to only allow requests that will find a match reach the broker, and short circuit other requests based on a self tuning probability. If the queue is slow because no counterparties are trying to match then the drop probability will reach 100% quickly and all requests will short circuit. This means the queue management will also act as a circuit breaker if all requests would be dropped/fail. The PIE meter does not combine well with a last in, first out queue because newer requests are dequeued first and can make the queue appear fast. If a (misbehaving) client or application is sending significantly more requests then it will gain a similar proportion of matches. To avoid this situation sbroker_fair_queue can be used to load balance clients (or workers) on the broker itself. The fair queue creates one queue per application, client or other value and dequeues using a round robin strategy. Queues are created on demand and removed when no longer used. The CoDel algorithm works better with the fair queue than without because it can differentiate between flows. However the PIE meter does not combine well because it can not differentiate between the different flows and will see heavily fluctuating SojournTime values. It is also possible to load balance requests between multiple brokers with srand and sscheduler . These choose a random broker or a broker based on scheduler id. One of these can be combined with the sbetter load balancer that tries to even out the random load balancing by occasionally comparing the sojourn times on two random brokers and choosing the broker with the shortest sojourn time. All three of these load balancing modules can be used to load balance any OTP process. === Relative Time and Regulation === A negative RelativeTime means the counterparty sent their request before the caller and the counterparty waited for the caller. A positive value means the counterparty sent their request after the caller and the caller waited for the counterparty. A value of 0 means the match occured &quot;immediately&quot; for both requests. Therefore RelativeTime is a measure of the difference in queue speeds if the broker was so fast that it used zero processing time. This value can be used to measure the queue congestion, e.g. more ask than ask_r requests would mean ask request are waiting and get postive RelativeTime on matches and ask_r are getting matched immediately and get negative RelativeTime values. Unfortunately the broker is not infinitely fast and there is a process delaying. The total processing time while waiting for a match can then be calculated with SojournTime - max(RelativeTime, 0) . If the broker is handling a lot of requests the SojournTime can grow even if RelativeTime is negative, giving the false impression that the queue is congested (though it may also be congested). The contribution of load and queue congestion are indistinguishable and likely irrelevant to an end user client. Therefore the sbroker_queue callback modules use SojournTime when deciding whether to drop requests. A group of &quot;worker&quot; processes whose role is to serve end user clients as quickly as possible should try to minimise the SojournTime of the clients. The only thing the worker's can do to keep the client's queue fast and uncongested is to keep worker requests in the workers queue so clients match immediately and aren't queued, or are queued for as little as possible. Therefore the goal of the workers is to keep their queue slow so the client queue is fast. The simplest method to minimise client sojourn time is to queue workers as much as possible. Unfortunately if workers are used then it is safe to assume the workers are holding a resource that is expensive to create and/or maintain - otherwise they are not required. Therefore a second goal of the workers is keep their size minimised and so don't want to queue as many workers as possible on the broker. A simple approach to this is to maintain a minimal group of workers and to increase their size if a client request arrives when a worker isn't queued. In the most naive method the client is matched with the new worker but then it has to wait for the worker to create its resource. For example, wait for a TCP socket to connect and possibly more handshaking, such as TLS or other authorisation and setup. Alternatively the client waits for the next worker to be ready, which could be the newly created worker. However with RelativeTime the group of workers can continuously monitor the queue congestion and pre-emptively create a worker before the empty worker queue situation occurs. One approach is to try to maintain a RelativeTime above a certain value by creating a worker every time it is below a certain value. Effectively trying to keep the worker queue slightly slow so the client queue is always fast. This is an extension of the previous approach where a worker was created when the RelativeTime is less than or equal to 0 . For example, create a worker when workers send a request less than 100 milliseconds before clients send a request, i.e. RelativeTime &lt; 100 milliseconds. See sregulator and sregulator_relative_valve for more information. If the SojournTime is used to gauge queue congestion in the worker's queue, the same issue occurs in the workers as the clients: unable to distinguish between load and queue congestion. Therefore a load spike could be misinterpretted as an increase in worker queue congestion, i.e. a decrease in client queue congestion or a fast client queue. The opposite could be true if the increase in load is due to a burst of client requests. The RelativeTime can fluctate due to short bursts and the new workers may get created but once created are no longer required. To differentiate between a short burst and a longer term change in request rate the minimum RelativeTime over an interval time can be used instead. If the local maximum is below the target create a worker. This can be repeated with decreasing intervals until the no longer need more workers. Decreasing consecutive intervals ensures that long term changes are adapted too without reacting too quickly to an initial burst. See sregulator_codel_valve for more information. A sregulator is similar to a sbroker , except the regulator acts as the ask_r side and controls matching with ask requests using an sregulator_valve . - module ( sregulator_example ) . - behaviour ( sregulator ) . - export ( [ start_link / 0 ] ) . - export ( [ init / 1 ] ) . start_link ( ) -&gt; sregulator : start_link ( ? MODULE , undefined , [ ] ) . init ( _ ) -&gt; QueueSpec = { sbroker_timeout_queue , \#{ timeout =&gt; 200 } } , ValveSpec = { sregulator_relative_valve , \#{ target =&gt; 100 , min =&gt; 4 , max =&gt; 16 } , { ok , { QueueSpec , ValveSpec , [ ] } } . The sregulator_relative_valve will increase the size above the minimum 4 when updated with a relative time below 100 milliseconds up to a maximum size 16 . Then to use the regulator: { go , Ref , Pid , _ , _ } = sregulator : ask ( sregulator_example ) . The sregulator is updated using the sregulator_update_meter in either a sbroker or sregulator , or explicitly using sregulator:update/3 and sregulator:cast/2 : { sregulator_update_meter , [ { sregulator_example , ask_r , \#{ update =&gt; 200 } } ] } This will meter will update sregulator_example with the RelativeTime of the ask_r queue around every 200 milliseconds. A common pattern is as follows: init ( ) -&gt; { go , Ref , Pid , _ , _ } = sregulator : ask ( sregulator_example ) , % create any resources after go from sregulator loop ( Ref , Pid ) . loop ( Ref , Pid ) -&gt; % The regulated queue is `ask_r` so sregulator_update_meter uses `ask_r` too case sbroker : ask_r ( sbroker_example ) of { go , _ , _ , _ , _ } -&gt; % stuff happens loop ( Ref , Pid ) ; { drop , _ } -&gt; % dropped by queue, maybe shrink drop ( Ref , Pid ) end . drop ( Ref , Pid ) -&gt; case sregulator : continue ( Pid , Ref ) of { go , Ref , Pid , _ , _ } -&gt; % continue loop with same Ref as before loop ( Ref , Pid ) ; { stop , _ } -&gt; % process should stop its loop and Ref is removed from sregulator stop ( ) end . stop ( ) -&gt; % clean up any resources init ( ) .","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"The main roles of a pool are: dispatching, back pressure, load shedding, worker supervision and resizing. Existing pooling solutions assume if a worker is alive it is ready to handle work. If a worker isn't ready a client must wait for it be ready, or error immediately, when another worker might be ready to successfully handle the request. If workers explicitly control when they can are available then the pool can always dispatch to workers that are ready. Therefore in an ideal situation clients are requesting workers and workers are requesting clients. This is the broker pattern, where both parties are requesting a match with the counter party. For simplicity the same API can be used for both and so to the broker both parties are clients. Existing pooling solutions that support back pressure use a timeout mechanism where clients are queued for a length of time and then give up. Once clients start timing out, the next client in the queue is likely to have waited close to the time out. This leads to the situation where clients are all queued for approximately the time out, either giving up or getting a worker. If clients that give up could give up sooner then all clients would spend less time waiting but the same number would be served. Therefore in an ideal situation a target queue time would be chosen that keeps the system feeling responsive and clients would give up at a rate such that in the long term clients spend up to the target time in the queue. This is sojourn (queue waiting) time active queue management. CoDel and PIE are two state of the art active queue management algorithms with a target sojourn time, so should use those with defaults that keep systems feeling responsive to a user. Existing pooling solutions that support load shedding do not support back pressure. These use ETS as a lock system and choose a worker to try. However other workers might be available but are not tried or busy wait is used to retry multiple times to gain a lock. If clients could use ETS to determine whether a worker is likely to be available we could use existing dispatch and back pressure mechanisms. Therefore we want to limit access to the dispatching process by implementing a sojourn time active queue management algorithm using ETS in front of the dispatching process. Fortunately this is possible with the basic version of PIE. Existing pooling solutions either don't support resize or grow the pool when no workers are immediately available. However that worker may need to setup an expensive resource and is unlikely to be ready immediately. If workers are started early then the pool will be less likely to have no workers available. However the same pools that start workers &quot;too late&quot; also start new workers for every client that tries to checkout when no workers are available. However old workers will become available again, perhaps before new workers are ready. This often leads to too many workers getting started and wastes resources until they are reaped for being idle. If workers are started at intervals then temporary bursts would not start too many workers but persistent increases would still cause adequate growth. Therefore we want workers to be started when worker availability is running low but with intervals between starting workers. This can be achieved by sampling the worker queue at intervals and starting a worker based on the reading. This is the load regulator pattern, where the concurrency limit of tasks changes based on sampling. For simplicity the same API as the broker could be used, where the regulator is also the counterparty to the workers. Existing pooling solutions that also support resizing use a temporary a supervisor and keep restarting workers if they crash, equivalent to using max restarts infinity. Unfortunately these pools can't recover from faults due to bad state because the error does not bubble up the supervision tree and trigger restarts. They are &quot;too fault tolerant&quot; because the error does not spread far enough to trigger recovery. A pool where workers crash every time is not useful. Therefore we want workers to be supervised using supervisors with any configuration so the user can decide exactly how to handle failures. Fortunately using both the broker and regulator patterns allows workers to be started under user defined supervisors.","ref":"readme.html#motivation","title":"Overview - Motivation","type":"extras"},{"doc":"Copyright 2014 James Fish Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"1.1 - Add circuit breaker sregulator valves 1.2+ - Add improved queue management algorithms when possible, if at all","ref":"readme.html#roadmap","title":"Overview - Roadmap","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added rebar3_hank [Paulo Oliveira] rebar3_ex_doc + make ex_doc-dry [Paulo Oliveira] Changed CI container approach to setup-beam with cache [Paulo Oliveira] edoc -based doc. to ex_doc -based doc. [Paulo Oliveira]","ref":"changelog.html#1-1-1-2022-04-19","title":"Changelog - [1.1.1] - 2022-04-19","type":"extras"},{"doc":"Added elvis -based Erlang style analysis [Paulo Oliveira] Makefile [Paulo Oliveira] a fresh touch to rebar.config [Paulo Oliveira] Changed CI from Travis to GitHub Actions [Paulo Oliveira] Removed include/ [Paulo Oliveira] rebar.test.config [Paulo Oliveira]","ref":"changelog.html#1-1-0-2021-03-04","title":"Changelog - [1.1.0] - 2021-03-04","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;{}&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright {yyyy} {name of copyright owner} Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]